
package com.sundata.filter;

import java.io.IOException;
import java.util.UUID;

import org.slf4j.MDC;
import org.springframework.stereotype.Component;

import jakarta.servlet.Filter;
import jakarta.servlet.FilterChain;
import jakarta.servlet.FilterConfig;
import jakarta.servlet.ServletException;
import jakarta.servlet.ServletRequest;
import jakarta.servlet.ServletResponse;

/**
 * 生成在日志中使用的跟踪ID
 */
@Component
public class TraceFilter implements Filter {
    @Override
	public void init(FilterConfig filterConfig) {
	}

    @Override
    public void destroy() {
    }

	@Override  
	public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {
		MDC.put("TRACE_ID", UUID.randomUUID().toString());
		chain.doFilter(request, response);
    }
}

