package com.sundata.internalevaluation.calc.calcUnit.interfaces;

public interface InterfaceRunning {

    /**
     * 加密逻辑
     * @param interfaceStr 待处理字符串
     * @return 加密后逻辑
     */
    String encode(String interfaceStr);

    /**
     * 解密逻辑
     * @param encodeString 待处理字符串
     * @return 解密后的逻辑
     */
    String decode(String encodeString);

    /**
     * 根据解密后的报文内容，对报文内容做出一定的处理
     * @param interfaceNo 接口编号
     * @param interfaceStr 待处理字符串
     * @param calculateInstanceNumber 计算实例编号
     * @return 处理后的字符串报文
     */
    String afterDecode(String interfaceNo, String interfaceStr, String calculateInstanceNumber);

    /**
     * 处理后的报文内容，若需要映射为对象，则对象内容应当具备初始化方法与getset 方法来提供映射逻辑，简而言之，类似于 将json 或 xml 转化为model对象
     * @param interfaceStr 经过处理后的json 报文或 xml 报文
     * @param clazz 需要被转化的对象类型
     * @return 对象
     * @param <T> 对象实例
     */
    <T> T coverObject(String interfaceStr, Class<T> clazz);

}
