package com.sundata.internalevaluation.calc.running.threads;

import com.sundata.internalevaluation.calc.running.threads.fianl.CalcTaskResultType;

import java.util.Map;
import java.util.Objects;
import java.util.StringJoiner;

public class CalcTaskResult {

    private CalcTaskResultType resultType;
    private String code;
    private String result;
    private String message;
    private Map<String ,Object> resultMap;

    public CalcTaskResult(CalcTaskResultType resultType, String code, String message, Map<String, Object> resultMap) {
        this.resultType = resultType;
        this.code = code;
        this.result = resultType.getValue();
        this.message = message;
        this.resultMap = resultMap;
    }

    public CalcTaskResult(CalcTaskResultType resultType, String code, String result, String message, Map<String, Object> resultMap) {
        this.resultType = resultType;
        this.code = code;
        this.result = result;
        this.message = message;
        this.resultMap = resultMap;
    }

    public CalcTaskResultType getResultType() {
        return resultType;
    }

    public void setResultType(CalcTaskResultType resultType) {
        this.resultType = resultType;
        this.result  = resultType.getValue();
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getResult() {
        return result;
    }

    public void setResult(String result) {
        this.result = result;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public Map<String, Object> getResultMap() {
        return resultMap;
    }

    public void setResultMap(Map<String, Object> resultMap) {
        this.resultMap = resultMap;
    }

    @Override
    public String toString() {
        return new StringJoiner(", ", CalcTaskResult.class.getSimpleName() + "[", "]")
                .add("resultType=" + resultType)
                .add("code='" + code + "'")
                .add("result='" + result + "'")
                .add("message='" + message + "'")
                .add("resultMap=" + resultMap)
                .toString();
    }

    @Override
    public boolean equals(Object o) {
        if (o == null || getClass() != o.getClass()) return false;

        CalcTaskResult that = (CalcTaskResult) o;
        return getResultType() == that.getResultType() && Objects.equals(getCode(), that.getCode()) && Objects.equals(getResult(), that.getResult()) && Objects.equals(getResultMap(), that.getResultMap());
    }

    @Override
    public int hashCode() {
        int result1 = Objects.hashCode(getResultType());
        result1 = 31 * result1 + Objects.hashCode(getCode());
        result1 = 31 * result1 + Objects.hashCode(getResult());
        result1 = 31 * result1 + Objects.hashCode(getResultMap());
        return result1;
    }
}
