package com.sundata.internalevaluation.calc.util;

import cn.hutool.extra.spring.SpringUtil;
import org.springframework.jdbc.core.JdbcTemplate;

import javax.sql.DataSource;

/**
 * Created by IntelliJ IDEA.
 *
 * @author JoeLazy
 * @date 2025-04-27 16:25:14
 * @description: Jdbc工具类
 */
public class JdbcUtils {

    private static volatile JdbcTemplate jdbcTemplate = null;

    public static JdbcTemplate getJdbcTemplate() {
        if (jdbcTemplate == null) {
            synchronized (JdbcUtils.class) {
                if (jdbcTemplate == null) {
                    jdbcTemplate = SpringUtil.getBean(JdbcTemplate.class);
                    if (jdbcTemplate == null){
                        jdbcTemplate = new JdbcTemplate(SpringUtil.getBean(DataSource.class));
                    }
                }
            }
        }
        return jdbcTemplate;
    }
}
