package com.sundata.internalevaluation.configuration.controller;

import cn.hutool.core.util.StrUtil;
import com.sundata.common.base.BaseAction;
import com.sundata.internalevaluation.configuration.model.IndexModel;
import com.sundata.internalevaluation.configuration.service.IndexConfigService;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/internalevaluation/configuration/IndexConfigAction")
public class IndexConfigAction extends BaseAction {

    @Autowired
    IndexConfigService indexConfigService;

    /**
     * @author: 张艳杰
     * @methodsName: getDataList
     * @description: 指标配置初始化
     * @param: HttpServletRequest request, HttpServletResponse response,@RequestBody IndexModel model
     * @return: List<IndexModel>
     * @throws:
     */
    @RequestMapping({"getDataList"})
    public List<IndexModel> getDataList(HttpServletRequest request, HttpServletResponse response,
                                        @RequestBody IndexModel model) {
        return indexConfigService.getDataList(model);

    }

    /**
     * @author: 张艳杰
     * @methodsName: createData
     * @description: 指标配置新增
     * @param: HttpServletRequest request, HttpServletResponse response,@RequestBody IndexModel model
     * @return:
     * @throws:
     */
    @RequestMapping({"createData"})
    public void createData(HttpServletRequest request, HttpServletResponse response,
                           @RequestBody IndexModel model) {
        indexConfigService.createData(model);
    }

    /**
     * @author: 张艳杰
     * @methodsName: deleteRows
     * @description: 指标配置删除
     * @param: HttpServletRequest request, HttpServletResponse response,@RequestBody IndexModel model
     * @return:
     * @throws:
     */
    @RequestMapping({"deleteRows"})
    public void deleteRows(HttpServletRequest request, HttpServletResponse response,
                           @RequestBody IndexModel model) {
        indexConfigService.deleteRows(model);
    }

    /**
     * @author: 张艳杰
     * @methodsName: updateExistData
     * @description: 指标配置修改
     * @param: HttpServletRequest request, HttpServletResponse response,@RequestBody IndexModel model
     * @return:
     * @throws:
     */
    @RequestMapping({"updateExistData"})
    public void updateExistData(HttpServletRequest request, HttpServletResponse response,
                                @RequestBody IndexModel model) {
        indexConfigService.updateExistData(model);
    }

    /**
     * @author: 张艳杰
     * @methodsName: selectDetailData
     * @description: 指标配置查询
     * @param: HttpServletRequest request, HttpServletResponse response,@RequestBody IndexModel model
     * @return:
     * @throws:
     */
    @RequestMapping({"selectDetailData"})
    public IndexModel selectDetailData(HttpServletRequest request, HttpServletResponse response,
                                       @RequestBody IndexModel model) {

//        System.out.println("****** 计算开始 *******");
//        IndexModel configModel = new IndexModel();
//        configModel.setIndexNo("001");
//        configModel.setIndexName("测试");
//        CalcTaskResult calc = CalcUtil.calc("INDEX"+System.currentTimeMillis(),
//                new IndexCalcUnit(configModel.getIndexNo(),configModel.getIndexName(), Map.of(),configModel,indexConfigService),Map.of());
//
//        System.out.println("结果："+calc);

        return indexConfigService.selectDetailData(model);
    }


    /**
     * 指标配置查询
     * @param request 请求对象实体
     * @param response 响应对象实体
     * @param model 参数
     */
    @RequestMapping("isNotExist")
    public void isNotExist(HttpServletRequest request, HttpServletResponse response,
                           @RequestBody IndexModel model) {

        if (model != null && StrUtil.isNotBlank(model.getIndexNo())){
            if (indexConfigService.isNotExist(model) != null) {
                sendData(response,"该代码已存在");
            }else{
                sendData(response,true);
            }
        }else{
            sendData(response,true);
        }
    }



}
