package com.sundata.internalevaluation.configuration.controller;

import com.sundata.common.base.BaseAction;
import com.sundata.internalevaluation.configuration.model.IndexSetModel;
import com.sundata.internalevaluation.configuration.service.IndexSetService;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/internalevaluation/configuration/IndexListConfigAction")
public class IndexListConfigAction extends BaseAction {
    
    @Autowired
    IndexSetService indexSetService;

    /**
     * @author: 张艳杰
     * @methodsName: getDataList
     * @description: 指标清单配置初始化
     * @param: HttpServletRequest request, HttpServletResponse response,@RequestBody IndexSetModel model
     * @return: List<IndexSetModel>
     * @throws:
     */
    @RequestMapping({"getDataList"})
    public List<IndexSetModel> getDataList(HttpServletRequest request, HttpServletResponse response,
                                           @RequestBody IndexSetModel model) {
        return indexSetService.getDataList(model);
    }

    /**
     * @author: 张艳杰
     * @methodsName: createData
     * @description: 指标清单配置新增
     * @param: HttpServletRequest request, HttpServletResponse response,@RequestBody IndexSetModel model
     * @return:
     * @throws:
     */
    @RequestMapping({"createData"})
    public void createData(HttpServletRequest request, HttpServletResponse response,
                           @RequestBody IndexSetModel model) {
        indexSetService.createData(model);
    }

    /**
     * @author: 张艳杰
     * @methodsName: deleteRows
     * @description: 指标清单配置删除
     * @param: HttpServletRequest request, HttpServletResponse response,@RequestBody IndexSetModel model
     * @return:
     * @throws:
     */
    @RequestMapping({"deleteRows"})
    public void deleteRows(HttpServletRequest request, HttpServletResponse response,
                           @RequestBody IndexSetModel model) {
        indexSetService.deleteRows(model);
    }

    /**
     * @author: 张艳杰
     * @methodsName: updateExistData
     * @description: 指标清单配置修改
     * @param: HttpServletRequest request, HttpServletResponse response,@RequestBody IndexSetModel model
     * @return:
     * @throws:
     */
    @RequestMapping({"updateExistData"})
    public void updateExistData(HttpServletRequest request, HttpServletResponse response,
                                @RequestBody IndexSetModel model) {
        indexSetService.updateExistData(model);
    }


    /**
     * @author: 张艳杰
     * @methodsName: selectDetailData
     * @description: 指标清单配置查询
     * @param: HttpServletRequest request, HttpServletResponse response,@RequestBody IndexSetModel model
     * @return:
     * @throws:
     */
    @RequestMapping({"selectDetailData"})
    public IndexSetModel selectDetailData(HttpServletRequest request, HttpServletResponse response,
                                          @RequestBody IndexSetModel model) {
        return indexSetService.selectDetailData(model);
    }
}
