package com.sundata.internalevaluation.configuration.controller;

import com.sundata.common.base.BaseAction;
import com.sundata.internalevaluation.configuration.model.Rule;
import com.sundata.internalevaluation.configuration.service.RuleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @author JoeLazy
 */
@RestController
@RequestMapping("/nprule")
public class RuleController extends BaseAction {

    @Autowired
    private RuleService ruleService;

    /**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
    @RequestMapping("list")
    public List<Rule> listAll(@RequestBody Rule rule) {
        return ruleService.listAll(rule);
    }


    /**
     * 根据主键查询
     *
     * @param rule 主键
     * @return 返回记录，没有返回null
     */
    @RequestMapping("getById")
    public Rule getById(@RequestBody Rule rule) {
//        RuleSet rules = new RuleSet();
//        rules.setRulesNo("rules1001");
//        rules.setRulesName("年龄判断");
//        System.out.println("****** 计算开始 *******");
//        CalcTaskResult calc = CalcUtil.calc("waterNo:" + System.currentTimeMillis(),
//                new RulesCalcUnit(rules.getRulesNo(), rules.getRulesName(), Map.of(), rules, sysReqRuleService),
//                Map.of());
//
//        System.out.println("结果："+calc);

        return ruleService.getById(rule.getRuleNo());
    }    
     
    /**
     * 新增，忽略null字段
     *
     * @param rule 新增的记录
     * @return 返回影响行数
     */
    @RequestMapping("insert")
    public int insert(@RequestBody Rule rule) {
        return ruleService.insertIgnoreNull(rule);
    }    
      
    /**
     * 修改，忽略null字段
     *
     * @param rule 修改的记录
     * @return 返回影响行数
     */
    @RequestMapping("update")
    public int update(@RequestBody Rule rule) {
        return ruleService.updateIgnoreNull(rule);
    }
    
    /**
     * 删除记录
     *
     * @param rule 待删除的记录
     * @return 返回影响行数
     */
    @RequestMapping("delete")
    public int delete(@RequestBody Rule rule) {
        return ruleService.delete(rule);
    }
    
}