package com.sundata.internalevaluation.configuration.mapper;

import com.sundata.internalevaluation.configuration.model.DataItemConfigModel;
import com.sundata.internalevaluation.configuration.model.DataSourceModel;
import com.sundata.internalevaluation.configuration.model.InputParamModel;
import com.sundata.internalevaluation.configuration.model.QueryLogicModel;

import java.util.List;

public interface DataSourcesMapper {
    List<DataSourceModel> getDataList(DataSourceModel model);

    List<InputParamModel> getInputParamList(String dataSourcesNo);

    List<DataItemConfigModel> getDataItemConfigList(String dataSourcesNo);

    List<QueryLogicModel> getQueryLogicList(String dataSourcesNo);

    void createData(DataSourceModel model);

    int createInputParamData(InputParamModel inputParam);

    int createDataItemConfigData(DataItemConfigModel dataItemConfig);

    int createQueryLogicData(QueryLogicModel queryLogic);

    void deleteRows(DataSourceModel model);

    void updateExistData(DataSourceModel model);

    void deleteInputParamRows(DataSourceModel model);

    void deleteDataSourceRows(DataSourceModel model);

    void deleteQueryLogicRows(DataSourceModel model);

    DataSourceModel selectDetailData(String dataSourcesNo);
}
