package com.sundata.internalevaluation.configuration.mapper;

import com.sundata.internalevaluation.configuration.model.Interface;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;


@Mapper
public interface InterfaceMapper {

	/**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
	List<Interface> listAll(Interface anInterface);


	/**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
	Interface getById(String id);

	/**
     * 新增，忽略null字段
     *
     * @param interfaceModel 新增的记录
     * @return 返回影响行数
     */
	int insertIgnoreNull(Interface interfaceModel);
	
	/**
     * 修改，修改所有字段
     *
     * @param interfaceModel 修改的记录
     * @return 返回影响行数
     */
	int update(Interface interfaceModel);
	
	/**
     * 删除记录
     *
     * @param interfaceModel 待删除的记录
     * @return 返回影响行数
     */
	int delete(Interface interfaceModel);
	
}