package com.sundata.internalevaluation.configuration.mapper;

import com.sundata.internalevaluation.configuration.model.InterfaceParam;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface InterfaceParamMapper {

	/**
     * 新增，忽略null字段
     *
     * @param interfaceParam 新增的记录
     * @return 返回影响行数
     */
	int insertIgnoreNull(InterfaceParam interfaceParam);
	
	/**
     * 修改，修改所有字段
     *
     * @param interfaceParam 修改的记录
     * @return 返回影响行数
     */
	int update(InterfaceParam interfaceParam);

	/**
	 * 根据接口编号删除几口参数
	 * @param interfaceNo 接口编号
	 * @return 列表
	 */
    List<InterfaceParam> getByInterfaceNo(@Param("interfaceNo") String interfaceNo);

	/**
	 * 根据接口编号删除接口参数
	 *
	 * @param interfaceNo 接口id
	 * @return 影响行数
	 */
	int deleteByInterfaceNo(@Param("interfaceNo") String interfaceNo);

}