package com.sundata.internalevaluation.configuration.mapper;

import com.sundata.internalevaluation.configuration.model.Rule;
import com.sundata.internalevaluation.configuration.model.RuleIndex;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface RuleMapper {

	/**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
	List<Rule> listAll(Rule rule);


	/**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
	Rule getById(String ruleNo);

	
	/**
     * 新增，忽略null字段
     *
     * @param rule 新增的记录
     * @return 返回影响行数
     */
	int insertIgnoreNull(Rule rule);

	
	/**
     * 修改，忽略null字段
     *
     * @param rule 修改的记录
     * @return 返回影响行数
     */
	int updateIgnoreNull(Rule rule);
	
	/**
     * 删除记录
     *
     * @param rule 待删除的记录
     * @return 返回影响行数
     */
	int delete(Rule rule);

	List<Rule> selectRuleListByRulesNo(@Param("rulesNo") String rulesNo);


	/**
	 * 根据规则编号删除所有指标
	 * @param ruleNo 规则编号
	 * @return 返回影响行数
	 */
	int deleteIndexByRuleNo(@Param("ruleNo") String ruleNo);


	/**
	 * 插入所有规则 指标管关联关系
	 * @param ruleIndex 实体信息
	 * @return 返回影响行数
	 */
	int insertIndex(RuleIndex ruleIndex);

	/**
	 * 根据规则的编号  查询关联的指标
	 * @param ruleNo 规则编号
	 * @return 返回集合
	 */
	List<String> selectIndexByRuleNo(@Param("ruleNo") String ruleNo);

	/**
	 * 根据规则的编号  查询关联的指标
	 * @param ruleNo 规则编号
	 * @return 返回集合
	 */
	List<RuleIndex> selectRuleIndexListByRuleNo(@Param("ruleNo") String ruleNo);
}