package com.sundata.internalevaluation.configuration.mapper;

import com.sundata.internalevaluation.configuration.model.RuleSet;
import com.sundata.internalevaluation.configuration.model.RuleSetRule;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface RuleSetMapper {

	/**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
	List<RuleSet> listAll(RuleSet ruleSet);


	/**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
	RuleSet getById(@Param("rulesNo") String rulesNo);

	
	/**
     * 新增，忽略null字段
     *
     * @param ruleSet 新增的记录
     * @return 返回影响行数
     */
	int insertIgnoreNull(RuleSet ruleSet);
	


	
	/**
     * 修改，忽略null字段
     *
     * @param ruleSet 修改的记录
     * @return 返回影响行数
     */
	int updateIgnoreNull(RuleSet ruleSet);
	
	/**
     * 删除记录
     *
     * @param ruleSet 待删除的记录
     * @return 返回影响行数
     */
	int delete(RuleSet ruleSet);


	/**
	 * 根据规则编号删除关联的规则
	 * @param rulesNo 规则集编号
	 * @return 删除行数
	 */
	int deleteAssociateRuleByRulesNo(String rulesNo);

	/**
	 * 插入 规则和规则集的关联关系
	 * @param associateRules
	 * @return
	 */
	int insertAssociateRule(RuleSetRule associateRule);


	/**
	 *
	 */
	List<String> selectRuleByRulesNo(@Param("rulesNo") String rulesNo);


	List<String> selectRulesByRuleNo(@Param("ruleNo") String ruleNo);

}