package com.sundata.internalevaluation.configuration.model;

import java.util.List;

/**
 * Created by IntelliJ IDEA.
 *
 * @author JoeLazy
 * @date 2025-01-17 17:04:29
 * @description: 接口实体 请求接口信息表
 */

public class Interface {
    /**
     * 主键
     */
    private String id;
    /**
     * 接口名称
     */
    private String interfaceName;
    /**
     * 接口类型 代码
     */
    private String interfaceTypeCode;
    /**
     * 请求类型名称
     */
    private String interfaceTypeName;
    /**
     * ip地址
     */
    private String interfaceIp;
    /**
     * 端口
     */
    private String interfacePort;
    /**
     * 接口地址
     */
    private String interfaceUrl;
    /**
     * 请求接口内容类型编码
     */
    private String reqContentTypeCode;
    /**
     * 请求接口内容类型名称
     */
    private String reqContentTypeName;
    /**
     * 请求接口报文体模板
     */
    private String reqBodyTemplate;
    /**
     * 加密逻辑
     */
    private String reqEncryptionLogic;
    /**
     * 接受参数类型编码
     */
    private String respParamTypeCode;
    /**
     * 接受参数类型名称
     */
    private String respParamTypeName;
    /**
     * 解密逻辑 （空 对应的JAVA对象名称）
     */
    private String decryptionLogic;
    /**
     * 解密后处理逻辑（空 对应的JAVA对象名称）
     */
    private String processLogic;
    /**
     * 处理后对象映射（空 类全名）
     */
    private String classNameMapping;
    /**
     * 映射后对象映射（空 对应的JAVA对象名称）
     */
    private String objNameMapping;
    /**
     * 创建人
     */
    private String createBy;
    /**
     * 创建时间
     */
    private String createTime;
    /**
     * 最后修改人
     */
    private String updateBy;
    /**
     * 最后修改时间
     */
    private String updateTime;

    /**
     * 请求方式
     */
    private String reqMethod;

    /**
     * 接口编号
     */
    private String interfaceNo;


    // ------------------------- 数据库不存在字段 -------------------
    private List<InterfaceParam> paramList;

    public String getInterfaceNo() {
        return interfaceNo;
    }

    public void setInterfaceNo(String interfaceNo) {
        this.interfaceNo = interfaceNo;
    }

    public String getReqMethod() {
        return reqMethod;
    }

    public void setReqMethod(String reqMethod) {
        this.reqMethod = reqMethod;
    }


    public List<InterfaceParam> getParamList() {
        return paramList;
    }

    public void setParamList(List<InterfaceParam> paramList) {
        this.paramList = paramList;
    }

    public Interface() {
    }

    public Interface(String id, String interfaceName, String interfaceTypeCode, String interfaceTypeName, String interfaceIp, String interfacePort, String interfaceUrl, String reqContentTypeCode, String reqContentTypeName, String reqBodyTemplate, String reqEncryptionLogic, String respParamTypeCode, String respParamTypeName, String decryptionLogic, String processLogic, String classNameMapping, String objNameMapping, String createBy, String createTime, String updateBy, String updateTime) {
        this.id = id;
        this.interfaceName = interfaceName;
        this.interfaceTypeCode = interfaceTypeCode;
        this.interfaceTypeName = interfaceTypeName;
        this.interfaceIp = interfaceIp;
        this.interfacePort = interfacePort;
        this.interfaceUrl = interfaceUrl;
        this.reqContentTypeCode = reqContentTypeCode;
        this.reqContentTypeName = reqContentTypeName;
        this.reqBodyTemplate = reqBodyTemplate;
        this.reqEncryptionLogic = reqEncryptionLogic;
        this.respParamTypeCode = respParamTypeCode;
        this.respParamTypeName = respParamTypeName;
        this.decryptionLogic = decryptionLogic;
        this.processLogic = processLogic;
        this.classNameMapping = classNameMapping;
        this.objNameMapping = objNameMapping;
        this.createBy = createBy;
        this.createTime = createTime;
        this.updateBy = updateBy;
        this.updateTime = updateTime;
    }

    /**
     * 获取
     * @return id
     */
    public String getId() {
        return id;
    }

    /**
     * 设置
     * @param id
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * 获取
     * @return interfaceName
     */
    public String getInterfaceName() {
        return interfaceName;
    }

    /**
     * 设置
     * @param interfaceName
     */
    public void setInterfaceName(String interfaceName) {
        this.interfaceName = interfaceName;
    }

    /**
     * 获取
     * @return interfaceTypeCode
     */
    public String getInterfaceTypeCode() {
        return interfaceTypeCode;
    }

    /**
     * 设置
     * @param interfaceTypeCode
     */
    public void setInterfaceTypeCode(String interfaceTypeCode) {
        this.interfaceTypeCode = interfaceTypeCode;
    }

    /**
     * 获取
     * @return interfaceTypeName
     */
    public String getInterfaceTypeName() {
        return interfaceTypeName;
    }

    /**
     * 设置
     * @param interfaceTypeName
     */
    public void setInterfaceTypeName(String interfaceTypeName) {
        this.interfaceTypeName = interfaceTypeName;
    }

    /**
     * 获取
     * @return interfaceIp
     */
    public String getInterfaceIp() {
        return interfaceIp;
    }

    /**
     * 设置
     * @param interfaceIp
     */
    public void setInterfaceIp(String interfaceIp) {
        this.interfaceIp = interfaceIp;
    }

    /**
     * 获取
     * @return interfacePort
     */
    public String getInterfacePort() {
        return interfacePort;
    }

    /**
     * 设置
     * @param interfacePort
     */
    public void setInterfacePort(String interfacePort) {
        this.interfacePort = interfacePort;
    }

    /**
     * 获取
     * @return interfaceUrl
     */
    public String getInterfaceUrl() {
        return interfaceUrl;
    }

    /**
     * 设置
     * @param interfaceUrl
     */
    public void setInterfaceUrl(String interfaceUrl) {
        this.interfaceUrl = interfaceUrl;
    }

    /**
     * 获取
     * @return reqContentTypeCode
     */
    public String getReqContentTypeCode() {
        return reqContentTypeCode;
    }

    /**
     * 设置
     * @param reqContentTypeCode
     */
    public void setReqContentTypeCode(String reqContentTypeCode) {
        this.reqContentTypeCode = reqContentTypeCode;
    }

    /**
     * 获取
     * @return reqContentTypeName
     */
    public String getReqContentTypeName() {
        return reqContentTypeName;
    }

    /**
     * 设置
     * @param reqContentTypeName
     */
    public void setReqContentTypeName(String reqContentTypeName) {
        this.reqContentTypeName = reqContentTypeName;
    }

    /**
     * 获取
     * @return reqBodyTemplate
     */
    public String getReqBodyTemplate() {
        return reqBodyTemplate;
    }

    /**
     * 设置
     * @param reqBodyTemplate
     */
    public void setReqBodyTemplate(String reqBodyTemplate) {
        this.reqBodyTemplate = reqBodyTemplate;
    }

    /**
     * 获取
     * @return reqEncryptionLogic
     */
    public String getReqEncryptionLogic() {
        return reqEncryptionLogic;
    }

    /**
     * 设置
     * @param reqEncryptionLogic
     */
    public void setReqEncryptionLogic(String reqEncryptionLogic) {
        this.reqEncryptionLogic = reqEncryptionLogic;
    }

    /**
     * 获取
     * @return respParamTypeCode
     */
    public String getRespParamTypeCode() {
        return respParamTypeCode;
    }

    /**
     * 设置
     * @param respParamTypeCode
     */
    public void setRespParamTypeCode(String respParamTypeCode) {
        this.respParamTypeCode = respParamTypeCode;
    }

    /**
     * 获取
     * @return respParamTypeName
     */
    public String getRespParamTypeName() {
        return respParamTypeName;
    }

    /**
     * 设置
     * @param respParamTypeName
     */
    public void setRespParamTypeName(String respParamTypeName) {
        this.respParamTypeName = respParamTypeName;
    }

    /**
     * 获取
     * @return decryptionLogic
     */
    public String getDecryptionLogic() {
        return decryptionLogic;
    }

    /**
     * 设置
     * @param decryptionLogic
     */
    public void setDecryptionLogic(String decryptionLogic) {
        this.decryptionLogic = decryptionLogic;
    }

    /**
     * 获取
     * @return processLogic
     */
    public String getProcessLogic() {
        return processLogic;
    }

    /**
     * 设置
     * @param processLogic
     */
    public void setProcessLogic(String processLogic) {
        this.processLogic = processLogic;
    }

    /**
     * 获取
     * @return classNameMapping
     */
    public String getClassNameMapping() {
        return classNameMapping;
    }

    /**
     * 设置
     * @param classNameMapping
     */
    public void setClassNameMapping(String classNameMapping) {
        this.classNameMapping = classNameMapping;
    }

    /**
     * 获取
     * @return objNameMapping
     */
    public String getObjNameMapping() {
        return objNameMapping;
    }

    /**
     * 设置
     * @param objNameMapping
     */
    public void setObjNameMapping(String objNameMapping) {
        this.objNameMapping = objNameMapping;
    }

    /**
     * 获取
     * @return createBy
     */
    public String getCreateBy() {
        return createBy;
    }

    /**
     * 设置
     * @param createBy
     */
    public void setCreateBy(String createBy) {
        this.createBy = createBy;
    }

    /**
     * 获取
     * @return createTime
     */
    public String getCreateTime() {
        return createTime;
    }

    /**
     * 设置
     * @param createTime
     */
    public void setCreateTime(String createTime) {
        this.createTime = createTime;
    }

    /**
     * 获取
     * @return updateBy
     */
    public String getUpdateBy() {
        return updateBy;
    }

    /**
     * 设置
     * @param updateBy
     */
    public void setUpdateBy(String updateBy) {
        this.updateBy = updateBy;
    }

    /**
     * 获取
     * @return updateTime
     */
    public String getUpdateTime() {
        return updateTime;
    }

    /**
     * 设置
     * @param updateTime
     */
    public void setUpdateTime(String updateTime) {
        this.updateTime = updateTime;
    }

    public String toString() {
        return "Interface{id = " + id + ", interfaceName = " + interfaceName + ", interfaceTypeCode = " + interfaceTypeCode + ", interfaceTypeName = " + interfaceTypeName + ", interfaceIp = " + interfaceIp + ", interfacePort = " + interfacePort + ", interfaceUrl = " + interfaceUrl + ", reqContentTypeCode = " + reqContentTypeCode + ", reqContentTypeName = " + reqContentTypeName + ", reqBodyTemplate = " + reqBodyTemplate + ", reqEncryptionLogic = " + reqEncryptionLogic + ", respParamTypeCode = " + respParamTypeCode + ", respParamTypeName = " + respParamTypeName + ", decryptionLogic = " + decryptionLogic + ", processLogic = " + processLogic + ", classNameMapping = " + classNameMapping + ", objNameMapping = " + objNameMapping + ", createBy = " + createBy + ", createTime = " + createTime + ", updateBy = " + updateBy + ", updateTime = " + updateTime + "}";
    }
}