package com.sundata.internalevaluation.configuration.service;

import com.sundata.internalevaluation.configuration.mapper.IndexListConfigMapper;
import com.sundata.internalevaluation.configuration.model.IndexSetModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @author JoeLazy
 */
@Service
public class IndexSetService {

    @Autowired
    IndexListConfigMapper indexListConfigMapper;


    /**
     * 指标清单配置初始化
     *
     * @param model 查询条件
     * @return 查询列表
     */
    public List<IndexSetModel> getDataList(IndexSetModel model) {
        return indexListConfigMapper.getDataList(model);
    }


    /**
     * 指标清单配置新增
     *
     * @param model 新增内容
     */
    public void createData(IndexSetModel model) {
        if (null != model && null != model.getIndexNos() && !model.getIndexNos().isEmpty()) {
            for (String s : model.getIndexNos()) {
                model.setIndexNo(s);
                indexListConfigMapper.createAssociation(model);
            }
        }
        indexListConfigMapper.createData(model);
    }


    /**
     * 指标清单配置删除
     *
     * @param model 删除条件
     */
    public void deleteRows(IndexSetModel model) {
        indexListConfigMapper.deleteRows(model.getIndexListNo());
        indexListConfigMapper.deleteAssociation(model.getIndexListNo());
    }


    /**
     * 指标清单配置修改
     *
     * @param model 修改内容
     */
    public void updateExistData(IndexSetModel model) {
        indexListConfigMapper.updateExistData(model);
        indexListConfigMapper.deleteAssociation(model.getIndexListNo());
        if (null != model.getIndexNos() && !model.getIndexNos().isEmpty()) {
            for (String s : model.getIndexNos()) {
                model.setIndexNo(s);
                indexListConfigMapper.createAssociation(model);
            }
        }
    }


    /**
     * 指标清单配置查询
     *
     * @param model 查询条件
     * @return 查询结果
     */
    public IndexSetModel selectDetailData(IndexSetModel model) {
        IndexSetModel selectModel = indexListConfigMapper.selectDetailData(model);
        List<String> indexList = new ArrayList<>();
        List<IndexSetModel> associationList = indexListConfigMapper.selectAssociation(selectModel);
        if (null != associationList && !associationList.isEmpty()) {
            for (IndexSetModel m : associationList) {
                indexList.add(m.getIndexNo());
            }
        }
        selectModel.setIndexNos(indexList);
        return selectModel;
    }
}
