package com.sundata.internalevaluation.script.model;

import cn.hutool.core.util.StrUtil;
import org.jetbrains.annotations.Nullable;

import java.util.Objects;
import java.util.StringJoiner;

public class ScriptModel {
    private String scriptStr;
    private String scriptId;
    public ScriptModel(@Nullable String scriptId,@Nullable String scriptStr) {
        if(StrUtil.isEmpty(scriptStr)) {
            throw new IllegalArgumentException("脚本内容为空，我滴妈你想干啥！");
        }
        if(StrUtil.isEmpty(scriptId)) {
            throw new IllegalArgumentException("脚本ID为空，我滴妈你想干啥！");
        }
        this.scriptStr = scriptStr;
        this.scriptId = scriptId;
    }
    public String getScriptStr() {
        return scriptStr;
    }
    public void setScriptStr(String scriptStr) {
        this.scriptStr = scriptStr;
    }
    public String getScriptId() {
        return scriptId;
    }
    public void setScriptId(String scriptId) {
        this.scriptId = scriptId;
    }

    public ScriptModel(){}

    @Override
    public String toString() {
        return new StringJoiner(", ", ScriptModel.class.getSimpleName() + "[", "]")
                .add("scriptStr='" + scriptStr + "'")
                .add("scriptId='" + scriptId + "'")
                .toString();
    }

    @Override
    public boolean equals(Object o) {
        if (o == null || getClass() != o.getClass()) return false;

        ScriptModel scriptModel = (ScriptModel) o;
        return Objects.equals(getScriptStr(), scriptModel.getScriptStr()) && Objects.equals(getScriptId(), scriptModel.getScriptId());
    }

    @Override
    public int hashCode() {
        int result = Objects.hashCode(getScriptStr());
        result = 31 * result + Objects.hashCode(getScriptId());
        return result;
    }
}
