package com.sundata.internalevaluation.script.pool;

import groovy.lang.Script;
import org.apache.commons.pool2.impl.GenericObjectPool;
import com.sundata.internalevaluation.script.model.ScriptModel;

public class GroovyScriptPool {
    // 创建一个 GroovyShell 的池
    public static GenericObjectPool<Script> createGroovyShellPool(ScriptModel scriptModel) {
        GroovyScriptFactory factory = new GroovyScriptFactory(scriptModel);
        GenericObjectPool<Script> pool = new GenericObjectPool<>(factory);
        // 配置池的参数，例如最大空闲实例数、最小空闲实例数等
        pool.setMaxIdle(10);
        pool.setMinIdle(2);
        pool.setMaxTotal(20);
        pool.setTestOnBorrow(true);
        pool.setTestOnReturn(true);
        return pool;
    }
}
