package com.sundata.internalevaluation.task;

import com.sundata.internalevaluation.business.model.IrbonlineAsynTaskInfo;
import com.sundata.internalevaluation.business.service.IrbonlineAsynTaskInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;

import java.util.List;

/**
 * Created by IntelliJ IDEA.
 *
 * @author JoeLazy
 * @date 2025-02-27 16:22:55
 * @description: 异步调用的规则集定时任务
 */

//@Configuration
@EnableAsync
@EnableScheduling
public class AsyncTask {

    @Autowired
    private IrbonlineAsynTaskInfoService irbonlineAsynTaskInfoService;


    @Async
    @Scheduled(fixedRate = 1000, initialDelay = 5000)
    public void asyncCalcRulesTask() {
        List<IrbonlineAsynTaskInfo> taskInfoListByStatus = irbonlineAsynTaskInfoService.getTaskInfoListByStatus("03");
        System.out.println("异步调用的规则集定时任务");
    }
}
